# PhasicFlow: src/phasicFlow/structuredData/pointStructure/pointStructure/pointSorting/mortonIndexing.hpp File Reference
PhasicFlow is an open-source parallel DEM (discrete element method) package for simulating granular flow. It is developed in C++ and can be exectued on both GPU (like CUDA) and CPU.

mortonIndexing.hpp File Reference
Include dependency graph for mortonIndexing.hpp:
This graph shows which files directly or indirectly include this file:

Go to the source code of this file.

## Classes

struct | indexMorton

## Namespaces

| pFlow

## Functions

uint32IndexContainer | getSortedIndices (box boundingBox, real dx, const ViewType1D< realx3 > &pos, const pFlagTypeDevice &flag)
INLINE_FUNCTION_HD uint64_t | splitBy3 (const uint64_t val)
INLINE_FUNCTION_HD uint64_t | xyzToMortonCode64 (uint64_t x, uint64_t y, uint64_t z)
INLINE_FUNCTION_HD uint64_t | getThirdBits (uint64_t x)
INLINE_FUNCTION_HD void | mortonCode64Toxyz (uint64_t morton, uint64_t &x, uint64_t &y, uint64_t &z)